/*
 * Buffer.cpp
 *
 *  Created on: Apr 1, 2011
 *      Author: lipari
 */

#include "Buffer.h"

using namespace std;

Buffer::Buffer(unsigned n, Block &o) : array(n), out(o)
{
	for (int i=0; i<0; ++i) array[i] = 0;
}

void Buffer::write(unsigned i, double value)
{
	if (i>=array.size()) throw "Out of bound";
	array[i] = value;
}

double Buffer::read(unsigned i)
{
	if (i>=array.size()) throw "Out of bound";
	return array[i];
}


InputPort::InputPort() : buffer(0), index(0)
{
}

double InputPort::read()
{
	if (buffer == 0) throw "Unlinked Input port";
	return buffer->read(index);

}

void InputPort::connect(Buffer &b, unsigned i)
{
	buffer = &b;
	index = i;
}

Block * InputPort::getPreviousBlock()
{
	return &buffer->getBlock();
}

/*vector<Block *> InputInterface::intPreviousBlocks()
{
	vector<Block *> tmp;

	for (unsigned i=0; i<in.size(); ++i)
		tmp.push_back(in[i].getPreviousBlock());
}*/
